// AecMfc32TimeCodeDlg.h : header file
//

#if !defined(AFX_AECMFC32TIMECODEDLG_H__F58FCDF1_3F43_479F_ACF6_EB644DCC7C88__INCLUDED_)
#define AFX_AECMFC32TIMECODEDLG_H__F58FCDF1_3F43_479F_ACF6_EB644DCC7C88__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "AecOSD.h"
class CAecOSDdlg;	
class CAecSony422;
class CAecSio;
class CAecL21;

/////////////////////////////////////////////////////////////////////////////
// CAecMfc32TimeCodeDlg dialog

class CAecMfc32TimeCodeDlg : public CDialog
{
// Construction
public:
	void OnWmOSD(WPARAM wp, LPARAM lp);
	void OnWmAecL21(WPARAM wP, LPARAM lP);
	void OnWmAecSIO(WPARAM wP, LPARAM lP);
	void OnWmAecSony422(WPARAM wP, LPARAM lP);
	void ProcessSyncChange(BYTE b);
	void InitGenStatusAll();
	void InitGenStatus();
	void InitStatus_N_Signals();
	void UpdateStatus_N_Signals();
	void ProcessIntEventCode(int);
	BOOL Poll_And_Process();
	CAecMfc32TimeCodeDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAecMfc32TimeCodeDlg)
	enum { IDD = IDD_AECMFC32TIMECODE_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAecMfc32TimeCodeDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	//CBitmapButton buttonUP;

	// Generated message map functions
	//{{AFX_MSG(CAecMfc32TimeCodeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonR1Go();
	afx_msg void OnButtonR4Go();
	afx_msg void OnButtonW1Go();
	afx_msg void OnButtonW4Go();
	afx_msg void OnButtonScGo();
	afx_msg void OnButtonVidCountZero();
	afx_msg void OnButtonPutFps();
	afx_msg void OnButtonJamgenall();
	afx_msg void OnButtonJamgentb();
	afx_msg void OnButtonJamgenub();
	afx_msg void OnButtonJamgeneb();
	afx_msg void OnCheckGenRununchangedstop();
	afx_msg void OnCheckGenPauseGo();
	afx_msg void OnCheckGenDisEnable();
	afx_msg void OnButtonForceGenUpdate();
	afx_msg void OnButtonForceReadUpdate();
	afx_msg void OnRadioSyncVid();
	afx_msg void OnRadioSyncLtc();
	afx_msg void OnRadioGenFreerun();
	afx_msg void OnCheckGendf();
	afx_msg void OnCheckGendown();
	afx_msg void OnCheckJamReader();
	afx_msg void OnCheckNojamub();
	afx_msg void OnButtonCmpstart();
	afx_msg void OnRadioCmpread();
	afx_msg void OnRadioCmpgen();
	afx_msg void OnButtonNext();
	afx_msg void OnButtonPrev();
	afx_msg void OnClose();
	afx_msg void OnCheckGenLtc();
	afx_msg void OnCheckGenVitc();
	afx_msg void OnCheckReadVitc();
	afx_msg void OnCheckReadLtc();
	afx_msg void OnCheckSony422Dlg();
	afx_msg void OnCheckL21Dlgbox();
	afx_msg void OnCheckOsdDlgbox();
	afx_msg void OnCheckIntL21on();
	afx_msg void OnCheckIntCmpon();
	afx_msg void OnCheckIntRxon();
	afx_msg void OnCheckIntTxon();
	afx_msg void OnCheckIntGenon();
	afx_msg void OnCheckIntVidon();
	afx_msg void OnCheckIntRdron();
	afx_msg void OnCheckIsrOnly();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnCancel();
	afx_msg void OnCheckGencf();
	afx_msg void OnRadioSyncLogic();
	afx_msg void OnButtonDoNtsc();
	afx_msg void OnButtonDoPal();
	afx_msg void OnButtonDoFilm();
	afx_msg void OnCheckSioGenericDlg();
	afx_msg void OnSimulateTimer();
	afx_msg void OnDestroy();
	afx_msg void OnCheckPollFast();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_IntUpdateCount;
	BOOLEAN m_PollFast;
	BOOLEAN b_ISRtranstion;
	BYTE m_sioBuff16[16];
	void WriteHexStringToEditBox(int nID, int len, LPWORD w);
	void WriteHexStringToEditBox(int nID, int len, LPDWORD dw);
	//~CAecMfc32TimeCodeDlg();
	CAecOSDdlg* pDlgOSD;
	CAecSony422* pDlgSony422;
	CAecSio* pDlgSIO;
	CAecL21* pDlgL21;

	int m_Dlg_Timer;};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AECMFC32TIMECODEDLG_H__F58FCDF1_3F43_479F_ACF6_EB644DCC7C88__INCLUDED_)
