// AecSio.cpp : implementation file
//

#include "stdafx.h"
#include "AecMfc32TimeCode.h"
#include "AecSio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAecSio dialog


CAecSio::CAecSio(CWnd* pParent /*=NULL*/)
	: CDialog(CAecSio::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAecSio)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pMainDlg = pParent;
	m_Hex = false;
	m_rxIndex = 0;
}


void CAecSio::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAecSio)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAecSio, CDialog)
	//{{AFX_MSG_MAP(CAecSio)
	ON_BN_CLICKED(IDC_CHECK_HEX, OnCheckHex)
	ON_BN_CLICKED(IDC_CLOSE_SIO, OnCloseSio)
	ON_BN_CLICKED(IDC_RADIO_BAUD_4800, OnRadioBaud4800)
	ON_BN_CLICKED(IDC_RADIO_BAUD_28000, OnRadioBaud28000)
	ON_BN_CLICKED(IDC_RADIO_BAUD_9600, OnRadioBaud9600)
	ON_BN_CLICKED(IDC_RADIO_BAUD_19200, OnRadioBaud19200)
	ON_BN_CLICKED(IDC_RADIO_BAUD_33000, OnRadioBaud33000)
	ON_BN_CLICKED(IDC_RADIO_BAUD_38400, OnRadioBaud38400)
	ON_BN_CLICKED(IDC_RADIO_BAUD_76800, OnRadioBaud76800)
	ON_BN_CLICKED(IDC_RADIO_PARITY_ODD, OnRadioParityOdd)
	ON_BN_CLICKED(IDC_RADIO_PARITY_EVEN, OnRadioParityEven)
	ON_BN_CLICKED(IDC_RADIO_PARITY_NONE, OnRadioParityNone)
	ON_BN_CLICKED(IDC_RADIO_BITS_8, OnRadioBits8)
	ON_BN_CLICKED(IDC_RADIO_BITS_7, OnRadioBits7)
	ON_BN_CLICKED(IDC_BUTTON_TX_CLEAR, OnButtonTxClear)
	ON_BN_CLICKED(IDC_BUTTON_RX_CLEAR, OnButtonRxClear)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_0, OnButtonLoad0)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_1, OnButtonLoad1)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_2, OnButtonLoad2)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_3, OnButtonLoad3)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_4, OnButtonLoad4)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_5, OnButtonLoad5)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_6, OnButtonLoad6)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_7, OnButtonLoad7)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_8, OnButtonLoad8)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_9, OnButtonLoad9)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_A, OnButtonLoadA)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_B, OnButtonLoadB)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_C, OnButtonLoadC)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_D, OnButtonLoadD)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_E, OnButtonLoadE)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_F, OnButtonLoadF)
	ON_BN_CLICKED(IDC_BUTTON_TX_0, OnButtonTx0)
	ON_BN_CLICKED(IDC_BUTTON_TX_1, OnButtonTx1)
	ON_BN_CLICKED(IDC_BUTTON_TX_2, OnButtonTx2)
	ON_BN_CLICKED(IDC_BUTTON_TX_3, OnButtonTx3)
	ON_BN_CLICKED(IDC_BUTTON_TX_4, OnButtonTx4)
	ON_BN_CLICKED(IDC_BUTTON_TX_5, OnButtonTx5)
	ON_BN_CLICKED(IDC_BUTTON_TX_6, OnButtonTx6)
	ON_BN_CLICKED(IDC_BUTTON_TX_7, OnButtonTx7)
	ON_BN_CLICKED(IDC_BUTTON_TX_8, OnButtonTx8)
	ON_BN_CLICKED(IDC_BUTTON_TX_9, OnButtonTx9)
	ON_BN_CLICKED(IDC_BUTTON_TX_A, OnButtonTxA)
	ON_BN_CLICKED(IDC_BUTTON_TX_B, OnButtonTxB)
	ON_BN_CLICKED(IDC_BUTTON_TX_C, OnButtonTxC)
	ON_BN_CLICKED(IDC_BUTTON_TX_D, OnButtonTxD)
	ON_BN_CLICKED(IDC_BUTTON_TX_E, OnButtonTxE)
	ON_BN_CLICKED(IDC_BUTTON_TX_F, OnButtonTxF)
	ON_BN_CLICKED(IDC_BUTTON_CLR_INPUT, OnButtonClrInput)
	ON_BN_CLICKED(IDC_RADIO_BAUD_2400, OnRadioBaud2400)
	ON_BN_CLICKED(IDC_BUTTON_INIT_SIO, OnButtonInitSio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::SendToMain(WPARAM wp, LPARAM lp)
{

	m_pMainDlg->SendMessage(WM_AEC_SIO, wp, lp);

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


/////////////////////////////////////////////////////////////////////////////
// CAecSio message handlers

void CAecSio::OnCheckHex() 
{
	// TODO: Add your control notification handler code here
	//Use the SetWindowLongPtr(   ) call to change to UPPERCASE ONLY
	// when this is CHECKED..., else set to either in NOT checked
	//ES_UPPERCASE
	if (IsDlgButtonChecked(IDC_CHECK_HEX))
	{
		m_Hex = true;
	}
	else m_Hex = false; 
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnCloseSio() 
{
	//send message that we want to close this dialog!
	SendToMain(CLOSE, 0);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud2400() 
{
	SendToMain(BAUD, (LPARAM)160);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud4800()		//IDC_RADIO_BAUD_4800
{

	SendToMain(BAUD, (LPARAM)80);	
}

/*
2400	160/0xA0
4800	80/0x50
9600	40/0x28
19200	20/0x14
//28000	13.71/0x0D
29500	13/0x0D
32000	12/0x0B
38400	10/0x0A
76800	5/0x05
BAUD		//3C
TIMEOUT		//3E
  */
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud9600()		//IDC_RADIO_BAUD_9600
{
	SendToMain(BAUD, (LPARAM)40);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud19200()	//IDC_RADIO_BAUD_19200
{
	SendToMain(BAUD, (LPARAM)20);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud28000()	//IDC_RADIO_BAUD_28000
{
	SendToMain(BAUD, (LPARAM)13);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud33000()	//IDC_RADIO_BAUD_33000
{
	SendToMain(BAUD, (LPARAM)12);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud38400()	//IDC_RADIO_BAUD_38400
{
	SendToMain(BAUD, (LPARAM)10);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBaud76800()	//IDC_RADIO_BAUD_76800
{
	SendToMain(BAUD, (LPARAM)5);	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioParityOdd()	//IDC_RADIO_PARITY_ODD
{
	m_BitsParity = (m_BitsParity | 0x80);	//set7
	m_BitsParity = (m_BitsParity & 0xBF);	//clr6

	GetDlgItem(IDC_RADIO_BITS_7)->EnableWindow(TRUE);
	SendToMain(BITSPARITY, (LPARAM) m_BitsParity);
}
// BITSPARITY	//3D	
//	7=> ODD(1),EVEN(0) / 6=>NONE(1), O/E(0) / 5=> 8bits(1), 7bits(0)  (note:x7none!)
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioParityEven()	//IDC_RADIO_PARITY_EVEN
{
	//m_BitsParity = (m_BitsParity | 0x00);	//set
	m_BitsParity = (m_BitsParity & 0x3F);	//clr76

	GetDlgItem(IDC_RADIO_BITS_7)->EnableWindow(TRUE);
	SendToMain(BITSPARITY, (LPARAM) m_BitsParity);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioParityNone()	//IDC_RADIO_PARITY_NONE
{
	m_BitsParity = (m_BitsParity | 0x60);	//set65 (none/8)
	//m_BitsParity = (m_BitsParity & 0x00);	//clr

	GetDlgItem(IDC_RADIO_BITS_7)->EnableWindow(FALSE);
	SendToMain(BITSPARITY, (LPARAM) m_BitsParity);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBits8()	//IDC_RADIO_BITS_8
{
	m_BitsParity = (m_BitsParity | 0x20);	//set5
	//m_BitsParity = (m_BitsParity & 0x00);	//clr

	GetDlgItem(IDC_RADIO_PARITY_NONE)->EnableWindow(TRUE);
	SendToMain(BITSPARITY, (LPARAM) m_BitsParity);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnRadioBits7()	//IDC_RADIO_BITS_7
{
	//m_BitsParity = (m_BitsParity | 0x00);	//set
	m_BitsParity = (m_BitsParity & 0x90);	//clr65 (o/e, 7)

	GetDlgItem(IDC_RADIO_PARITY_NONE)->EnableWindow(FALSE);
	SendToMain(BITSPARITY, (LPARAM) m_BitsParity);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxClear() 
{
	SetDlgItemText(IDC_EDIT_TXHEX, "");
	SetDlgItemText(IDC_EDIT_TXASCII, "");	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonRxClear() 
{
	SetDlgItemText(IDC_EDIT_RXHEX, "");
	SetDlgItemText(IDC_EDIT_RXASCII, "");
	m_rxIndex = 0;
	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int CAecSio::GetInput()
{
	BOOL lowNibble;
	int i = 0;
	int iPack, index, k, j;
	BYTE cTempStr[255];
	BYTE cSort[128];
	BYTE byte1, byteH, byteL;

	m_InLen = GetDlgItemText(IDC_EDIT_TX_INPUT, m_LdBuf, 255);
	//
	//do processing based upon HEX or regular input(ASCII)
	//if (IsDlgButtonChecked(IDC_CHECK_HEX))
	if (m_Hex)
	{
		//get rid of any spaces and if there is an "s" or "S",
		// then calculate the checksum of prior hex bytes
		iPack = 0;
		for (index = 0; index < m_InLen; index++)
		{
			byte1 = (BYTE)m_LdBuf[index];
			switch (byte1)
			{
				case '0':
					cTempStr[iPack] = 0x00;
					iPack++;
					break;
				case '1':
					cTempStr[iPack] = 0x01;
					iPack++;
					break;
				case '2':
					cTempStr[iPack] = 0x02;
					iPack++;
					break;
				case '3':
					cTempStr[iPack] = 0x03;
					iPack++;
					break;
				case '4':
					cTempStr[iPack] = 0x04;
					iPack++;
					break;
				case '5':
					cTempStr[iPack] = 0x05;
					iPack++;
					break;
				case '6':
					cTempStr[iPack] = 0x06;
					iPack++;
					break;
				case '7':
					cTempStr[iPack] = 0x07;
					iPack++;
					break;
				case '8':
					cTempStr[iPack] = 0x08;
					iPack++;
					break;
				case '9':
					cTempStr[iPack] = 0x09;
					iPack++;
					break;
				case 'A':
				case 'a':
					cTempStr[iPack] = 0x0A;
					iPack++;
					break;
				case 'B':
				case 'b':
					cTempStr[iPack] = 0x0B;
					iPack++;
					break;
				case 'C':
				case 'c':
					cTempStr[iPack] = 0x0C;
					iPack++;
					break;
				case 'D':
				case 'd':
					cTempStr[iPack] = 0x0D;
					iPack++;
					break;
				case 'E':
				case 'e':
					cTempStr[iPack] = 0x0E;
					iPack++;
					break;
				case 'F':
				case 'f':
					cTempStr[iPack] = 0x0F;
					iPack++;
					break;
				case ' ':
					//do nothing, just go on and pass over the space
					break;
				case 'S':
				case 's':	//put place holder to calculate a checksum for total so far
					cTempStr[iPack] = 'S';
					iPack++;
					break;
				default:	//do nothing, just drop this character and go on
					break;
			}			
		}
		k = 0;
		lowNibble = true;	
		for (index = 0; index < iPack; index++)
		{
			//Throw every other character into the low/high buffer
			byte1 = cTempStr[index];
			if (byte1 == 'S')
			{
				//calc. eight bit checksum
				//
				if (!lowNibble)	//if in the middle of packing byte 
				{					//when we receive CHKSUM					;
					cSort[k] = ((byteH * 0x10) + byteL);
					k++;
					lowNibble = true;
				}
				//now run chksum
				byte1 = 0;	//init cksum
				for (j = 0; j<k; j++)
				{
					byte1 += cSort[j];
				}
				cSort[k] = byte1;
				k++;
				lowNibble = true;
			}
			else if (lowNibble)
			{
				byteL = byte1;				
				byteH = 0x00;
				lowNibble = false;
			}
			else
			{
				byteH = byteL;
				byteL = byte1;
				cSort[k] = ((byteH * 0x10) + byteL);
				k++;
				lowNibble = true;
				
			}
		}

		if (!lowNibble)	//if in the middle of packing byte 
		{					//when we got to the end of the string				;
			cSort[k] = ((byteH * 0x10) + byteL);
			k++;
		}

		// k holds length
		for (j = 0; j<k; j++)
			m_ByteArray[j] = cSort[j];
		i = j;


	}
	else
	{
		for (j = 0; j<m_InLen; j++)
			m_ByteArray[j] = m_LdBuf[j];
		i = j;
	}
	return i;

}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::Stuff(LPARAM lp)
{
	BOOL	first = true;
	LPARAM stuff = lp;
	D4B16 z;	
	int i, j;
	int k;
	int len = GetInput();

	k = 0;
	j = 0;
	do
	{
		for (i=0; i < 0x10; i++)
		{
			if (first)
			{
				z.b[i] = (BYTE)len;	//put Length as FIRST byte
				first = false;
			}
			else
			{
				z.b[i] =  m_ByteArray[j++];

				
			}
		}
		if (stuff < (STUFF_F +1))	//don't do this work if it wont fit!
		{
			SendToMain(WRITE_0, (LPARAM) z.dw.d0);		
			SendToMain(WRITE_1, (LPARAM) z.dw.d1);
			SendToMain(WRITE_2, (LPARAM) z.dw.d2);
			SendToMain(WRITE_3, (LPARAM) z.dw.d3);

			SaveStuff(stuff, z.b);	//SAVE a COPY OF THE LOAD FOR DISPLAY later
			SendToMain(CMD, stuff++);
		}
		else
			k=0;
	}
	while (j < (len));
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::SaveStuff(int index, BYTE *b)
{
	int i, j;
	
	switch (index)
	{ 
		case STUFF_0:
			i = 0x00;
			break;
		case STUFF_1:
			i = 0x10;
			break;
		case STUFF_2:
			i = 0x20;
			break;
		case STUFF_3:
			i = 0x30;
			break;
		case STUFF_4:
			i = 0x40;
			break;
		case STUFF_5:
			i = 0x50;
			break;
		case STUFF_6:
			i = 0x60;
			break;
		case STUFF_7:
			i = 0x70;
			break;
		case STUFF_8:
			i = 0x80;
			break;
		case STUFF_9:
			i = 0x90;
			break;
		case STUFF_A:
			i = 0xA0;
			break;
		case STUFF_B:
			i = 0xB0;
			break;
		case STUFF_C:
			i = 0xC0;
			break;
		case STUFF_D:
			i = 0xD0;
			break;
		case STUFF_E:
			i = 0xE0;
			break;
		case STUFF_F:
			i = 0xF0;
			break;
		default:
			i = 0;
			break;
	}
	for (j = 0; j < 0x10; j++)
	{
		m_Stuffed[i++] = *b++;
	}
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad0() 
{
	Stuff(STUFF_0); 
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad1() 
{
	Stuff(STUFF_1);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad2() 
{
	Stuff(STUFF_2);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad3() 
{
	Stuff(STUFF_3);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad4() 
{
	Stuff(STUFF_4);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad5() 
{
	Stuff(STUFF_5);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad6() 
{
	Stuff(STUFF_6);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad7() 
{
	Stuff(STUFF_7);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad8() 
{
	Stuff(STUFF_8);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoad9() 
{
	Stuff(STUFF_9);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoadA() 
{
	Stuff(STUFF_A);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoadB() 
{
	Stuff(STUFF_B);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoadC() 
{
	Stuff(STUFF_C);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoadD() 
{
	Stuff(STUFF_D);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoadE() 
{
	Stuff(STUFF_E);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonLoadF() 
{
	Stuff(STUFF_F);	
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void CAecSio::TxDisplay(LPARAM tx_n)
{
	int i, j;//, k;
	int len;
	char as[256];
	char hex[512];
	char char2hex[4];
	char c;

	SendToMain(CMD, tx_n);
	//now display what is getting transmitted
	//based upon our storred string 'm_Stuffed' !

//	SetDlgItemText(IDC_EDIT_TXHEX, "");
//	SetDlgItemText(IDC_EDIT_TXASCII, "");
	
	//Get the address (sting index) of the first byte (Length) 
	//for the string that has been requested to be transmitted
	switch (tx_n)
	{ 
		case TX_0:
			i = 0x00;
			break;
		case TX_1:
			i = 0x10;
			break;
		case TX_2:
			i = 0x20;
			break;
		case TX_3:
			i = 0x30;
			break;
		case TX_4:
			i = 0x40;
			break;
		case TX_5:
			i = 0x50;
			break;
		case TX_6:
			i = 0x60;
			break;
		case TX_7:
			i = 0x70;
			break;
		case TX_8:
			i = 0x80;
			break;
		case TX_9:
			i = 0x90;
			break;
		case TX_A:
			i = 0xA0;
			break;
		case TX_B:
			i = 0xB0;
			break;
		case TX_C:
			i = 0xC0;
			break;
		case TX_D:
			i = 0xD0;
			break;
		case TX_E:
			i = 0xE0;
			break;
		case TX_F:
			i = 0xF0;
			break;
		default:
			i = 0;
			break;
	}
	len = (int) m_Stuffed[i++];	//length is first byte
	// if len == 0xff then BREAK?

	hex[0] = 0;	//init this string
	for (j = 0; j < len; j++)
	{
		c = (char)m_Stuffed[i++];	//get byte that has been saved
		if (i > 0xff)
			break;
		if (c < ' ')	//if not a a space or greater, assign place holder
			//as[j] = 0x7F;
			as[j] = 0x7E;
		else as[j] = c;	//else, assign the char to as!

		wsprintf (char2hex,"%2.2X ",(BYTE) c);
		strcat(hex, char2hex);
		
	}
	//strcat(hex, 0x00);
	as[j] = 0;		//eol
	//hex[2*j] = 0;	//eol

	//SetDlgItemText(nID, LPCTSTR);
	SetDlgItemText(IDC_EDIT_TXHEX, hex);
	SetDlgItemText(IDC_EDIT_TXASCII, as);

	return;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx0() 
{
	TxDisplay(TX_0);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx1() 
{
	TxDisplay(TX_1);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx2() 
{
	TxDisplay(TX_2);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx3() 
{
	TxDisplay(TX_3);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx4() 
{
	TxDisplay(TX_4);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx5() 
{
	TxDisplay(TX_5);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx6() 
{
	TxDisplay(TX_6);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx7() 
{
	TxDisplay(TX_7);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx8() 
{
	TxDisplay(TX_8);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTx9() 
{
	TxDisplay(TX_9);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxA() 
{
	TxDisplay(TX_A);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxB() 
{
	TxDisplay(TX_B);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxC() 
{
	TxDisplay(TX_C);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxD() 
{
	TxDisplay(TX_D);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxE() 
{
	TxDisplay(TX_E);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonTxF() 
{
	TxDisplay(TX_F);
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonClrInput() 
{
	SetDlgItemText(IDC_EDIT_TX_INPUT, "");
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecSio::OnButtonInitSio() 
{
	SendToMain(CMD, (LPARAM) 0x80);	
	m_rxIndex = 0;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Receive the number (len) of bytes and process them
//The 's' will have high byte as STATUS and low byte as DATA
// 'len' is number of WORDs (ie: status/data pairs)
void CAecSio::ReceiveData(int len, LPWORD s)
{
	//TxComplete = TRUE;
	for (int i =0; i<len; i++)
	{
//		if (m_rxIndex > 19)
///		{
//			//something has gone wrong!)
//			//m_rxIndex = 0;
//			//m_RxEvent = FALSE;
//			//m_tmr = TIMEOUT_SONY;
//			//RxComplete = TRUE;
//			return;
//		}
		m_rxW[m_rxIndex] = s[i];
		m_rxIndex++;
	}
	m_tmr = 0;	//reset timer to 0
	m_RxEvent = TRUE;
	//m_RxDataReady = ProcessRxData();
	ProcessRxData();

}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL CAecSio::ProcessRxData()
{
	//See if timeout or if have finished receiving string
	//check m_rxW[0] low nibble for "len" to see if it matches
	// m_rxIndex...


	int i, j;//, k;
	int len = m_rxIndex;
	char as[256];
	char hex[512];
	char char2hex[4];
	char c;
	WB2 rx;

	//display what is received
	hex[0] = 0;	//init this string
	for (j = 0; j < len; j++)
	{
		rx.W = m_rxW[j];
		//process the string
		//check the STATUS of each byte and add to display strings
/*
status: 
bit7 => 1 if status and data are valid
bit6 => 1 if some previous data was lost (buffer ovr)
bit5 => 1 if RESERVED
bit4 => 1 if Rx timeout
bit3 => 1 if framing error
bit2 => 1 if overrun error
bit1 => 1 if BREAK
bit0 => 1 if Parity error
*/
//		if ((rx.B.H & 0x7F) != 0)	//if not all OK
//		{
//			if (rx.B.H & 0x10)
//			{
//				//we have an RX timeout
//				//Add code here to work with timeout...
//			}
//			else
//			{
//				//we have an error
//				//Add code here to work with error handling
//			}
//		}			

		c = (char)rx.B.L;
		as[j] = CharProc(c);
		wsprintf (char2hex,"%2.2X ",(BYTE) c);
		strcat(hex, char2hex);
		
	}
	as[j] = 0;		//eol
	//SetDlgItemText(nID, LPCTSTR);
	SetDlgItemText(IDC_EDIT_RXHEX, hex);
	SetDlgItemText(IDC_EDIT_RXASCII, as);

	//for now, keep the received string to a maximum size
	if (m_rxIndex > 250)
		m_rxIndex = 0;

	return true;;
	
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



char CAecSio::CharProc(char c)
{
	char ch;
	switch (c)
	{
		case 0x00:
			ch = 0x7F;
			break;
		case 0x01:
			ch = 0x7F;
			break;
		case 0x02:
			ch = 0x7F;
			break;
		case 0x03:
			ch = 0x7F;
			break;
		case 0x04:
			ch = 0x7F;
			break;
		case 0x05:
			ch = 0x7F;
			break;
		case 0x06:
			ch = 0x7F;
			break;
		case 0x07:
			ch = 0x07;	//BEL
			break;
		case 0x08:
			ch = 0x7F;
			break;
		case 0x09:
			ch = 0x7F;
			break;
		case 0x0A:		//LF
			ch = 0x0A;
			break;
		case 0x0B:
			ch = 0x7F;
			break;
		case 0x0C:
			ch = 0x7F;
			break;
		case 0x0D:		//CR
			ch = 0x0D;
			break;
		case 0x0E:
			ch = 0x7F;
			break;
		case 0x0F:
			ch = 0x7F;
			break;
		case 0x10:
			ch = 0x7F;
			break;
		case 0x11:
			ch = 0x7F;
			break;
		case 0x12:
			ch = 0x7F;
			break;
		case 0x13:
			ch = 0x7F;
			break;
		case 0x14:
			ch = 0x7F;
			break;
		case 0x15:
			ch = 0x7F;
			break;
		case 0x16:
			ch = 0x7F;
			break;
		case 0x17:
			ch = 0x7F;
			break;
		case 0x18:
			ch = 0x7F;
			break;
		case 0x19:
			ch = 0x7F;
			break;
		case 0x1A:
			ch = 0x7F;
			break;
		case 0x1B:
			ch = 0x7F;
			break;
		case 0x1C:
			ch = 0x7F;
			break;
		case 0x1D:
			ch = 0x7F;
			break;
		case 0x1E:
			ch = 0x7F;
			break;
		case 0x1F:
			ch = 0x7F;
			break;
		default:
			ch = c;
			break;
	}
	return ch;

}
